<?php
  session_start();
  require_once 'setup.php';

  $user_reset = new USER();

  // If already Logged-in Redirect to Home
  if($user_reset->is_logged_in()!="")
  { $user_reset->redirect('home.php'); }

  if(isset($_POST['btn-submit']))
  {
     $email = $_POST['txtemail'];
     
     $stmt = $user_reset->runQuery("SELECT userID FROM tbl_users WHERE userEmail=:email LIMIT 1");
     $stmt->execute(array(":email"=>$email));
     $row = $stmt->fetch(PDO::FETCH_ASSOC); 

     if($stmt->rowCount() == 1)
     {
        $id   = base64_encode($row['userID']) ;
        $code = md5(uniqid(rand())) ;
        $jump = "resetpw"  ;  

        try
        {   $stmt = $user_reset->runQuery("UPDATE tbl_users SET tokenCode=:token WHERE userEmail=:email");
            $stmt->execute(array(":token"=>$code,"email"=>$email));
            // Send the Reset Email
              try
              {  
                  $subject  = "Password Reset";

                  $message= "
                     Hello ".$email.",
                     <br /><br />
                     We were requested to reset your password for the ".$WelcomeTo." website, if you requested this, then please click the following link to reset your password, if not please ignore this email.
                     <br /><br />
                     Click the Following Link To Reset Your Password 
                     <br /><br />
                      <a href='".$MyDBLoginRoot."/springboard.php?id=".$id."&code=".$code."&jump=".$jump."'>
                        click here to reset your password
                      </a>
                     <br /><br />
                     Thank You,
                     " ;

                  $user_reset->send_mail($email,$message,$subject) ;
                      $msg = "We've sent an email to $email.<br />
                          Please follow the link in the email to get to the New Password Tool." ;
              }
              catch(PDOException $ex)
              { $msg = $ex->getMessage(); } 

          }  // Update DB
          catch(PDOException $ex)
          { $msg = $ex->getMessage(); }            

     }else // $stmt->rowCount() <> 1
     { $msg = "<strong>Sorry!</strong>  this email is not on the current authorized list." ; }
  } //isset($_POST['btn-submit']) 
?>


<!DOCTYPE html>
<html>
  <head>
    <title>Password Reset Request</title>
    <link rel="stylesheet"   href="login.css"  />
  </head>
  <body id="login">
    <div class="container">

      <form class="form-signin" method="post">
        <h1 class="form-signin-heading">Forgot Password</h1>
        <h3 class="form-signin-heading">Or, Want to Change It</h3>
        <hr />
        
        <div class="CommBox">
        <h3>  <?php 
                if(isset($msg))
                { echo $msg; }
                else
                { echo "Please enter your email address. You will receive a link to create a new password via email." ;
                } 
              ?>
        </h3>
        </div>
        
        <input  type="email" 
                class="input-block-level" 
                placeholder="Email address" 
                name="txtemail" 
                required 
                size="75" />
      <hr />
        <button class="btn btn-danger btn-primary" 
                type="submit" 
                name="btn-submit">
              Send Email Password Reset
        </button>
        <br /><br />
        <hr />
        Not Registered yet?<br />
        <h3><a href="signup.php" class="btn btn-large btn-primary" size="15">Sign Up</a></h3>
        <br />
        <hr />
        Or, if you are:<br />
        <h3><a href="index.php"> Just Sign In </a></h3>        
      </form>

    </div> <!-- /container -->
  </body>
</html>