<?php

## HTTPS / HTTP Auto-finder:
## Identify the site as either an https or an http site: and Assign it to a Constant
## The Next few Settings allow you to Localize the different PHP files ONCE then use 
## Variables instead of hard-code.  This makes migration and new installations easier!
  ## First we identify the site as either an https or an http site:
    if (check_https()) {
      if (!defined('WIKIHOST')){ define('WIKIHOST', 'https://'.$_SERVER['HTTP_HOST']); }
    } else {
      if (!defined('WIKIHOST')){ define('WIKIHOST', 'http://'.$_SERVER['HTTP_HOST']); }
    } 

//________________________________________________________________________________

## ! ! ! !  C H A N G E   T H E S E   F O R   Y O U R   L O C A T I O N   ! ! ! ! !

##  Define the Path to YOUR directory with pmwiki.php 
##   e.g. pmwiki is in www.myexample.com/pmwiki directory
  if (!defined('WIKIROOT')){ define('WIKIROOT', '/pmwiki'); }
  ##  If you just use a different name for the wiki folder it might look like:
  #   if (!defined('WIKIROOT')){ define('WIKIROOT', '/SomeFolder'); }

  ## Note if your installation is at the Domain level (not recommended) 
  ## For example all the PMWiki files are located at http://www.mysite.com/ then
  #  if (!defined('WIKIROOT')){ define('WIKIROOT', ''); } 

  ## Note if your installation several directories deep:
  ## For example  https://www.mysite.com/somedirectory/anotherone/pmwiki  then
  #  if (!defined('WIKIROOT')){ define('WIKIROOT', '/somedirectory/anotherone/pmwiki'); } 

## Now we need to set the location of your MyDBLogin files, AND for your Special Login page 
## for MyDBLogin.  If you use my example, that would be a dedicated group homepage
## just used for MyDBLogin:  
  // Here's where you have loaded the MyDBLogin php files:
   $MyDBLoginRoot = WIKIHOST."/mydblogin" ;   
  // Here's the PMWiki page with the includeSite link to the MyDBLogin  index.php file.
   $MyDBLoginWiki = WIKIHOST.WIKIROOT."/pmwiki.php/Portcullis/"; 
  // And here is the redirect page for failed authorizations:
  // (used in the /local/GroupName.php files) 
   $NoAuthPage ="/Portcullis/NoAuth" ;
  
  ## ! ! ! Please Note the MyDBLogin files should be in the SAME domain, but must NOT be in 
  ##       the PMWiki installation, otherwise you will not have authorization to see them!
  ##       For Example your PMWiki is at:  https://www.mydomain/pmwiki/
  ##       But your MyDBLogin files ar at: https://www.mydomain/mydblogin/
  ##
  ## Trouble-shooting? Try logging directly into the MyDBLogin files  
  ##       (Here's another reason not to put your PMWiki installation at the Web Root!)

## Use this setting to identify your Site in the Welcome / Verify emil for new Registrants
## Just use the Site Name or the Organization Name
  $SiteName     = "mydomain.org";

    $WelcomeTo  = "the $SiteName Website" ; // Displays as "the mydomain.org Website"


## Set the Database Credentials:
  define(DB_HOST,       'mysql.mydomain.org') ; 
  define(DB_NAME,       'mydomain_db') ;
  define(DB_USER,       'myUserName') ;
  define(DB_PWORD,      'SecretPW#1') ;      


## Set the Database information for the DB with the list of available User-Emails:
  define(DB_VALIDTABLE, 'tbl_whitelist') ;  // Table with allowable email list
  define(DB_MAILFIELD,  'curEmail') ;       // Field containing allowable emails
  define(DB_REG_USERS,  'tbl_users') ;      // Table of Registered Users
  define(DB_USER_EMAIL, 'userEmail') ;      // Field with Registered User emails


//-------------------------------------------------------------------------------
//------------------------ PHPMailer Settings -----------------------------------

## This Assumes PHPMailer has been installed and is in its default directory
  use PHPMailer\PHPMailer\PHPMailer;
  use PHPMailer\PHPMailer\Exception;

## Change to your Username:
  require '/home/username/PHPMailer/src/Exception.php';
  require '/home/username/PHPMailer/src/PHPMailer.php';
  require '/home/username/PHPMailer/src/SMTP.php';

## Configure to your email server account
  define(SMTPHOST,      'smtp.mydomain.org') ;
  define(SMTPMAILUSER,  'webmaster@mydomain.org') ;
  define(SMTPMAILPW,    'SecretPW#2') ;

  define(SMTPFROM,      'webmaster@mydomain.org') ;
  define(SMTPFROMTAG,   'Mydomain Website') ;
  define(SMTPTOTAG,     'Mydomain Visitor') ;






////_________________________________________________________________________________

//  YOU SHOULD NOT NEED TO CUSTOMIZE ANYTHING BELOW THIS LINE FOR A NORMAL INSTALL
//___________________________________________________________________________________




## Function to check if the current installation url uses an https or http prefix
function check_https() 
{  
  if ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443) 
  { return true; }
  else
  { return false;}
}


## There are two Classes here DATABASE and  USER
##
## Database: handles the Database Connection, and 
##
## User: handles 
## - Login/Logout routines, 
## - Registration with confirmation via Email
## - some Database functions

class Database
{
     
    ## Set the Database Credentials:     
    private $host     = DB_HOST;
    private $db_name  = DB_NAME;
    private $username = DB_USER;
    private $password = DB_PWORD;
    public  $conn;
     
    public function dbConnection()
    {     
        $this->conn = null; 

        try
        {
            $this->conn = new PDO("mysql:host=" . $this->host . ";dbname=" . $this->db_name, $this->username, $this->password);
            $this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION); 
        }
        catch(PDOException $exception)
        {   echo "Connection error: " . $exception->getMessage() ; }
         
        return $this->conn;
    }
}

class USER
{ 

  private $conn;
 
  public function __construct()
  {
    $database = new Database();
    $db = $database->dbConnection();
    $this->conn = $db;
  }
 
  public function runQuery($sql)
  { 
    $stmt = $this->conn->prepare($sql);
    return $stmt; 
  }
 
  public function lasdID()
  {
    $stmt = $this->conn->lastInsertId();
    return $stmt;
  }

  public function register($uname,$email,$upass,$code)
  {
    try
    {       
     $password = md5($upass);
     $stmt = $this->conn->prepare("INSERT INTO tbl_users(userName,userEmail,userPass,tokenCode) 
                                   VALUES(:user_name, :user_mail, :user_pass, :active_code)");
     $stmt->bindparam(":user_name",   $uname);
     $stmt->bindparam(":user_mail",   $email);
     $stmt->bindparam(":user_pass",   $password);
     $stmt->bindparam(":active_code", $code);
     $stmt->execute(); 
     return $stmt;
    }
    catch(PDOException $ex)
    {
     echo $ex->getMessage();
    }
  }

  public function login($email,$upass)
  {
    try
    {
     $stmt = $this->conn->prepare("SELECT * FROM tbl_users WHERE userEmail=:email_id");
     $stmt->execute(array(":email_id"=>$email));
     $userRow=$stmt->fetch(PDO::FETCH_ASSOC);
     
       if($stmt->rowCount() == 1)
       {
          if($userRow['userStatus']=="Y")
          {
             if($userRow['userPass']==md5($upass))
             {
                $_SESSION['userSession'] = $userRow['userID'];
                //$_SESSION['UserName'] = $email;
                //$_SESSION['userPW'] = $upass;

                return true;
             }
             else
             {
              header("Location: index.php?error");
              exit;
             }
          }
          else
          {
           header("Location: index.php?inactive");
           exit;
          } 
       }
       else
       {
        header("Location: index.php?error");
        exit;
       }  
    }
    catch(PDOException $ex)
    { echo $ex->getMessage(); }
  }
 
 
  public function is_logged_in()
  {
    if(isset($_SESSION['userSession']))
    { return true; }
  }
 
  public function redirect($url)
  {  header("Location: $url"); }
 
  public function logout()
  {
    session_destroy();
    $_SESSION['userSession'] = false;
  }
 

  /* -------- PHPMailer Send Mail Function ---------------------------------------- */
  function send_mail($email,$message,$subject)
  {      
    $mail = new PHPMailer(true);                              // Passing `true` enables exceptions
    try {
          //Assign Server settings
          $mail->SMTPDebug  = 0;                    // Enable verbose debug output
          $mail->isSMTP();                          // Set mailer to use SMTP
          $mail->Host       = SMTPHOST;             // Specify main and backup SMTP servers
          $mail->SMTPAuth   = true;                 // Enable SMTP authentication
          $mail->Username   = SMTPMAILUSER;     	// SMTP username
          $mail->Password   = SMTPMAILPW;           // SMTP password
          $mail->SMTPSecure = 'tls';                // Enable TLS encryption, `ssl` also accepted
          $mail->Port       = 587;                  // TCP port to connect to

          //Recipients
          $mail->setFrom(SMTPFROM, SMTPFROMTAG);   		//This is the email your form sends From
          $mail->addAddress($email, SMTPTOTAG);    		// Add a recipient address
          //$mail->addAddress('contact@example.com');   // Name is optional
          //$mail->addReplyTo('info@example.com', 'Information');
          //$mail->addCC('cc@example.com');
          //$mail->addBCC('bcc@example.com');

          //Attachments
          //$mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
          //$mail->addAttachment('/tmp/image.jpg', 'new.jpg');    // Optional name

          //Content
          $mail->isHTML(true);                                    // Set email format to HTML
          $mail->Subject = $subject;
          $mail->Body    = $message;
          //$mail->AltBody = 'This is the body in plain text for non-HTML mail clients';

          $mail->send() ;

          return '1 - Message has been sent' ;

    } catch (Exception $e) 
    {
        $retStr = "0 - Message could not be sent. \r\n Mailer Error: ".$mail->ErrorInfo ;
        return $retStr ;
    }
  } //  function send_mail
} //  class USER
